<?php
/**
 * Ich vermittle zwischen dem Shop und CMSimple
 *
 */
class ContentManager {
	var $contentFile;
	function ContentManager($contentFile) {
		$this -> contentFile = $contentFile;
	}
	function get_headings_of_level($level){
		$headings = array();
		$i = 0;   
		$alles = file($this -> contentFile);
		$alles = implode("\n", $alles);
		preg_match_all("/<h[1-3][^>]*>.*<\/h[1-3]>/i", $alles,$headings); 

		foreach($headings[0] as $heading){

		if(eregi('\<h'.$level.'\>',$heading)){
				$levelHeadings[$i]['counter'] = $i; 
				$levelHeadings[$i]['heading'] = strip_tags($heading);
			}
			$i++;	
		}
		return $levelHeadings;
	}
	function get_page_links($allButThisOne) {
		  global $u, $h, $l;   //url, heading, level
		  $links = '';
		  for($i = 0;$i < (count($u)); $i++) {
		    $spacer = '';
		    if($l[$i] > 1){
		    	$spacer = str_repeat('&nbsp;&nbsp;&nbsp;', $l[$i]);
		    }
		    	if($u[$i] !== $allButThisOne){
		    	$links[$i]['link'] = "?".$u[$i];
			    $links[$i]['page'] = $spacer.$h[$i];
		    	}
		   } 
		   return $links;
	}
	
	/**
	 * erwartet einen String - die aktuelle url
	 * gibt alle Seiten außer der aktuellen als
	 * ein Array von Assoziationen ['link']=>url,['page']=>heading
	 * zurück. die headings werden dabei je nach level eingerückt,
	 *
	 * @param string $allButThisOne
	 * @return array
	 */
	function get_all_pages_but($allButThisOne) {
		  global $u, $h, $l;   //url, heading, level
		  $links = '';
		  for($i = 0;$i < (count($u)); $i++) {
		    $spacer = '';
		    if($l[$i] > 1){
		    	$spacer = str_repeat('&nbsp;&nbsp;&nbsp;', $l[$i]);
		    }
		    	if($u[$i] !== $allButThisOne){
		    	$links[$i]['link'] = "?".$u[$i];
			    $links[$i]['page'] = $spacer.$h[$i];
		    	}
		   } 
		   return $links;
	}
	function insert_page($name,$content,$menuLevel,$position){
		global $c;
		$page = "<h$menuLevel>$name</h$menuLevel>";
		$page .= $content;
		if(!is_numeric($position)) {
				$c[]=$page;
			}else {
				array_splice($c,$position,0,$page);
		}
		return $c;
	}
	function update_page_on_position($position,$name,$content,$menuLevel){
		global $c;
		$page = "<h$menuLevel>$name</h$menuLevel>";
		$page .= $content;
		array_splice($c,$position,1,$page);
		return $c;
	}
	function move_page($pageName,$content,$menuLevel, $newPosition){
		global $c, $position;
		$oldPosition = $this -> get_position_of_page_named($pageName);
		unset($c[$oldPosition]);
		if($oldPosition < $newPosition) {$newPosition = $newPosition-1;}
		$this -> insert_page($pageName,$content,$menuLevel,$newPosition);
	}
	/**
	 * returns index of the page named $pageName
	 *
	 * @param string $pageName
	 * @return int
	 */
	function get_position_of_page_named($pageName) {
		global $c;
		$clean_up= array('('=>'\(',
				 		')'=>'\)',
				  		'+'=>'\+',
				  		'.'=>'\.',
				  		'*'=> '\*',
				  		'?'=>'\?',
				  		'$' => '\$',
				  		'#' => '\#',
			
				  	);
		$pageName= strtr($pageName,$clean_up);
		$i = 0;
		$t = implode($c);
		$headings = '';   
		preg_match_all("/<h[1-3][^>]*>.*<\/h[1-3]>/i", $t,$headings); 
		foreach($headings[0] as $heading){
			if(ereg($pageName,$heading)){
				return  $i;
			}
		$i++;	
		}
	}
	
	function delete_page_named($pageName){
		global $c;
		$position = $this -> get_position_of_page_named($pageName);
		array_splice($c,$position,1);
		return $c;
	}
	function delete_page_on_position($position){
		global $c;
		array_splice($c,$position-1,1);
	}
	function hide_page($pageName){
		global $c;
		$position = $this -> get_position_of_page_named($pageName);
		//array_splice($c,$position,1);
		$c[$position] = str_replace('#CMSimple hide#','',$c[$position]);
		$c[$position] = str_replace('</h1>','</h1>#CMSimple hide#',$c[$position]);
	}
	function save_the_new_content(){
		global $c;
		if ($fh = @ fopen($this -> contentFile, "w")) {
			fwrite($fh, '<html><head>'.head().'</head><body>'."\n");
			foreach ($c as $page) {
				if($page){
				fwrite($fh, rmnl($page."\n"));
				}
			}
			fwrite($fh, '</body></html>');
			fclose($fh);
			rfc();	
		}
	}
}
?>