<?php
/**
 * Ich stelle die Oberfläche für die Shop-Verwaltung zur Verfügung.
 *
 */
class OfficeDecorator {
	var $buttons, $headings, $labels, $hints, $settings, $zUrl, $settingsFile, $description_editor;
	function OfficeDecorator() {
		global $sl, $pth, $sn, $cf;
		$description_editor = NULL;
		if($cf['editor']['external']=="tinymce")
		{
			if($cf['tinymce']['folder']=='') {
				$cf['tinymce']['folder']='tiny_mce';
			}
			if(@is_dir($pth['folder']['base'].$cf['tinymce']['folder'])){
				$this -> description_editor = "TinyMCE";
			}

		}
		$zShopSettings = array();
		include $pth['folder']['plugins']."wellrad/config/shopsettings.php";
		include $pth['folder']['plugins'].'/wellrad/zShopLanguages/'.$sl.'.php';
		include_once $pth['folder']['plugins']."/wellrad/collaborators/contentmanager.inc";
		include_once $pth['folder']['plugins']."/wellrad/collaborators/htmlwriter.inc";
		$this -> language = $sl;
		$this -> buttons = $lang['buttons'];
		$this -> button_image_folder = $pth['folder']['plugins']. "wellrad/button_images/";
		$this -> labels = $lang['labels'];
		$this -> headings = $lang['headings'];
		$this -> hints = $lang['hints'];
		$this -> settings = $zShopSettings;
		$this -> zUrl = $zShopSettings[$sl]['url'];
		$this -> contentmanager = new ContentManager($pth['file']['content']);
		$this -> writer = new HtmlWriter($sl);
		/*
		 * TODO: Versionsnummer
		 */
		$this -> version = "wellrad! 1.0.6";
		

	}

	function prepare_the_form_for($task){
		if(method_exists($this, $task)) {
			return $this -> $task();
		} else {return '<p style="color: red">Oweh, das versteht der OfficeDecorator nicht: ('.$task.')!</p>';}
	}

	function make_administrators_menu() {
		$task = $_POST['task'];
		
		$return = "\n<p><b>".$this->version."</b> - made by zeichenkombinat.de</p><p>";
		$return .= $this -> make_main_tabs($task);
		if($task && ($task !== 'show_simpleShop_help')) {
			$return .=  $this -> make_the_subtabs($task);
		}
		return $return;
	}
	function make_main_tabs($task) {
		$return = "\n<div class =\"tabs\">";
		foreach($this -> settings['menu_bar'] as $tab) {
			$label = $this -> buttons[$tab];
			$class = "tab";
			if($task == $tab) {$class = "activeTab";}
			if(!$label) {$label = 'oops! hier fehlt eine Beschriftung! (in make_administrators_menu)';}
			$return .=  "\n<form action = \"?".$this ->zUrl."\" method = \"post\" class=\"$class\">";
			$return .= "\n\t<input type=\"hidden\" name=\"task\" value=\"$tab\" />";
			$return .= "\n\t<input type=\"submit\" value = \"$label\" class=\"$class\" />";
			$return .= "\n</form>\n";
		}
		$return .= "</div>\n";
		return $return;
	}



	function make_the_subtabs($task) {

		if(($task == 'shop_settings') || ($task == 'open_shop') || $_POST['settings_task']) {
			return  $this->make_the_shop_settings_menu();
		}
		if(($task == 'administrate_products')
		|| ($_POST['product_administration_task'])
		|| ($task == 'edit_product')
		|| ($task = 'delete_product')) {
			return  $this->make_the_product_administration_menu();
		}
		else {
			$return = "<p style=\"color: red\">Der OfficeDecorator versteht das nicht: $task!";
			$backtrace = debug_backtrace();
			foreach($backtrace as $back) {
				foreach($back['args'] as $arg) {
					$arguments = "$arg, ";
				}
				$file = explode('\\',$back['file']);
				$file = $file[count($file)-1];
				if(isset($back['class'])) {
	 			$return .= "<br /><b>". $back['class'] ."</b> -> ". $back['function']. "($arguments)";
	 			$return .= '<br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;  (<i>Datei: '. $file. ' Zeile: '. $back['line'].'</i>)';
				}
				else {
					$return .= '<br /><b>'. $file. '</b> Zeile: '. $back['line'].'<br />';
					$return .= "&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;".$back['function']. "($arguments)";
				}
			}
			$return .= '</p>';
			return $return;
		}
		//return $return;
	}



	function make_the_shop_settings_menu() {
		$task = $_POST['settings_task'];
		if(!$task) {$task = 'make_the_main_settings';}
		$return = "\n<div class =\"subtabs\">";
		foreach($this -> settings['shop_setting_tabs'] as $tab) {
			$label = $this -> buttons[$tab];
			$class = "subtab";
			if($task == $tab) {$class = "activeSubtab";}
			if(!$label) {$label = 'oops! hier fehlt eine Beschriftung! (in make_the_shop_settings_menu)';}
			$return .=  "\n<form action = \"?".$this ->zUrl."\" method = \"post\" class=\"$class\">";
			$return .= "\n\t<input type=\"hidden\" name=\"task\" value=\"shop_settings\" />";
			$return .= "\n\t<input type=\"hidden\" name=\"settings_task\" value=\"$tab\" />";
			$return .= "\n\t<input type=\"submit\" value = \"$label\" class=\"$class\" />";
			$return .= "\n</form>\n";
		}
		$return .= "</div>\n";
		return $return;
	}
	function make_the_product_administration_menu() {
		$task = $_POST['product_administration_task'];
		if(!$task) {
			$task = 'list_products';
		}
		$return = "\n<div class =\"subtabs\">";
		foreach($this -> settings['product_tabs'] as $tab) {
			$label = $this -> buttons[$tab];
			$class = "subtab";
			if($task == $tab) {$class = "activeSubtab";}
			if(!$label) {$label = 'oops! hier fehlt eine Beschriftung! (in make_the_shop_settings_menu)';}
			$return .=  "\n<form action = \"?".$this ->zUrl."\" method = \"post\" class=\"$class\">";
			$return .= "\n\t<input type=\"hidden\" name=\"task\" value=\"administrate_products\" />";
			$return .= "\n\t<input type=\"hidden\" name=\"product_administration_task\" value=\"$tab\" />";
			$return .= "\n\t<input type=\"submit\" value = \"$label\" class=\"$class\" />";
			$return .= "\n</form>\n";
		}
		$return .= "</div>\n";
		return $return;
	}



	function offer_shop_making() {
		$t = false;
		$headings = $this -> contentmanager -> get_headings_of_level('1');
		$headings_without_shopName = '';
		$the_one_after= null;
		foreach($headings as $heading){
			if($t) {$the_one_after = $heading;}
			if($heading['heading'] !== $this -> settings[$this->language]['shopName']){
				$headings_without_shopName[] = $heading;
				$t = false;
			}else{$t = true;}
		}

		$return .= "\n<form action=\"?&wellrad\" method=\"post\" name=\"shopMaker\">";
		$return .= $this -> hints['offer_shop_making'];
		$headings = $this -> contentmanager -> get_headings_of_level('1');
		$input = new Input();
		$input -> properties = array("type" => "text",
								"name" => "shopName",
								"value" => "Demo-Shop",
								"size" => 30);
		$return .= $input -> display_yourself();
		$input -> properties = array("type" => "hidden",
								"name" => "task",
								"value" => "open_a_shop");
		$return .= $input -> display_yourself();
		$return .= $this -> make_shop_position_input($this -> language, $headings_without_shopName, false);
		$return .= "\n\t<p style=\"text-align: right\">";
		$input -> properties = array("type" => "submit",
								"value" => $this -> buttons['save_settings']);
		$return .= $input -> display_yourself();
		$return .= "\n\t</p>\n</form>";
		return $return;
	}




	function make_the_main_settings() {
		global $sl,$s;
		$t = false;
		$headings = $this -> contentmanager -> get_headings_of_level('1');
		$headings_without_shopName = '';
		$the_one_after= null;
		foreach($headings as $heading){
			if($t) {$the_one_after = $heading;}
			if($heading['heading'] !== $this -> settings[$sl]['shopName']){
				$headings_without_shopName[] = $heading;
				$t = false;
			}else{$t = true;}
		}
		$action = "?" . $this->settings[$sl]['url'];
		$return = "\n<div class = \"settingsForm\">";
		$return .= "\n<form action = \"$action\" method = \"post\" name=\"shopMaker\" >";
		$return .= $this -> make_shop_name_input($sl);
		$return .= $this -> make_shop_position_input($sl, $headings_without_shopName, $the_one_after);
		$return .= $this -> make_shop_status_input($sl);
		//$return .= $this -> make_product_chunk_input($sl);
		$return .= $this -> make_use_categories_input($sl);
		$return .= $this -> make_cos_page_input($sl, $headings_without_shopName);
		$return .= "\n\t<p style='text-align: right;'><input type= \"hidden\" name=\"task\" value=\"save_settings\" />";
		$return .= "\n\t<input type= \"hidden\" name=\"settings_task\" value=\"make_the_main_settings\" />";
		$return .= "\n\t<input type = \"submit\" value=\"". $this -> buttons['save_settings']. "\" /></p>";
		$return .= "\n</form>\n</div>\n";
		return $return;
	}


	function make_shop_name_input($sl) {
		$value = stripslashes($this -> settings[$sl]['shopName']);
		$return  = "\n\t<p><label>". $this -> labels['zShop_name'] . "  ";
		$return .= "\n\t\t<input type=\"text\" name=\"shopName\" value=\"$value\" size = \"30\" />";
		$return .= "\n\t</label></p>";
		return $return;
	}

	function make_shop_status_input($sl) {
		$return = "\n\t<p>";
		$return .= $this -> labels['zShop_published']. "<br />";
		if($this -> settings['published']=='true')
		{$checked = 'checked';}
		$return .= "\n\t\t<label><input name=\"published\" value=\"true\"  type=\"radio\" $checked  />";
		$return .= $this -> labels['is_published'].'</label>';
		$checked= '';
		if($this -> settings['published']=='false')
		{$checked = 'checked';}
		$return .= "\n\t\t<label><input name=\"published\" value=\"false\"  type=\"radio\" $checked />";
		$return .= $this -> labels['is_hidden'].'</label>';
		return $return;
	}

	function make_shop_position_input($sl, $headings_without_shopName, $the_one_after) {
		$return = "\n\t<p>". $this -> labels['zShop_placement']."<br />";
		$js = "onclick=\"window.document.shopMaker.shopAtIndex.disabled=true\";";
		$checked = null;
		if(!$the_one_after){$checked = true;}
		$return .= "<label>".$this -> writer ->make_input_element('radio','shopAtLast','true','',$checked,$js);
		$return .=  $this -> labels['as_last_page']."</label>";
		$js = "onclick=\"window.document.shopMaker.shopAtIndex.disabled=false\"";
		if($the_one_after){$checked = 'jaja';}
		$return .= "<label>".$this -> writer ->make_input_element('radio','shopAtLast','false','',$the_one_after,$js);
		$return .= $this -> labels['place_before']."</label>";
		$selected = '';
		$disabled = 'disabled';
		if($the_one_after){$selected = $the_one_after['counter']; $disabled = null;}
		$return .= $this -> writer -> make_select_options($headings_without_shopName,'shopAtIndex',$selected,'','',$disabled);
		$return = '<p>'.$return.'</p>';
		return $return;
	}

	function make_cos_page_input($sl, $headings_without_shopName) {
		$agb = "<p>". $this -> labels['your_cos_page'];
		$pages = $headings_without_shopName;
		$agb .= "\n<select name=\"cos_page\" />";
		$agb .= "\n\t<option value=\"\">not linked</option>";
		$warning = "<p style=\"font-weight: bold; color: red\">".$this -> labels['warn_missing_cos']."</p>";
		foreach ($pages as $page) {
			$selected = '';
			if(($this->settings[$sl]['cos_page'])==$page['heading']) {
				$selected = 'selected';
				$warning = '';
			}
			$agb .= "\n\t<option $selected value =\"".$page['heading']."\">".$page['heading']."</option>";
		}
		$agb .= "\n</select></p>$warning";
		return $agb;
	}

/*
 * erstmal gestrichen
 */
	function make_product_chunk_input() {
		$return = "\n\t<p>Wie sollen die Produkte angezeigt werden?<br />";
		$checked = '';
		if($this->settings['product_list_chunk']== 0) {
			$checked = 'checked';
		}
		$return .= "\n\t\t<label><input type=\"radio\" $checked name=\"product_list_chunk\" value=\"0\" onclick=\"window.document.shopMaker.list_chunk_input.disabled=true\" />alle auf einmal</label>";
		$checked = '';
		$disabled= 'disabled';
		$number = 4;
		if($this->settings['product_list_chunk']> 0) {
			$checked = 'checked';
			$number = $this->settings['product_list_chunk'];
			$disabled = '';
		}
		$return .= "<input $checked type=\"radio\" name=\"product_list_chunk\" value=\"0\" onclick=\"window.document.shopMaker.list_chunk_input.disabled=false\" />";
		$return .= "<label><input id=\"list_chunk_input\" $disabled type=\"text\" name=\"product_list_chunk\" value=\"".$number."\" size=\"2\" style=\"width: 2em;\"/> pro Seite</label>";
		$return .= '</p>';
		return $return;
	}

	function make_use_categories_input() {
		$checked = '';
		if($this->settings['use_categories']=='true') {
			$checked='checked';
		}


		$return = '<p>'.$this->labels['use_category_selector'].'<br />';
		$return .= "\n".'<label>'.$this->labels['yes'].'<input  type="radio" '.$checked.' name="use_categories" value="true" onclick="window.document.shopMaker.allow_show_all.disabled=false"/></label>';
		$checked = '';
		if($this->settings['use_categories']=='false') {
			$checked='checked';
			$disabled = 'disabled';}
			$return .= "\n".'<label>'.$this->labels['no'].'<input  type="radio" '.$checked.' name="use_categories" value="false" onclick="window.document.shopMaker.allow_show_all.disabled=true" /></label></p>';
			//	$return .= "\n".'<label>'.$this->labels['allow_show_all'].'<input  type="checkbox" '.$checked.' name="allow_show_all" value="false"  /></label></p>';

			$return .= "\n<p>";
				
			return $return;
	}
	function make_the_contact_settings() {
		$helper = new HtmlWriter();
		$return = "\n<div class = \"settingsForm\">";
		$return .= "\n<form method=\"post\" action=\"\">";
		$contactInputs = $this -> labels['contact'];
		foreach($contactInputs as $name => $label){
			$return .= "\n\t<p><label>$label<br /><input type=\"text\" name=\"$name\" value=\"". $this  -> settings[$name]."\" size=\"31\" /></label></p>";
		}
		$return .= "\n\t<input type=\"hidden\" name=\"task\" value=\"save_settings\" />";
		$return .= "\n\t".'<p style="text-align: right;"><input type="submit" value="'. $this->buttons['save_settings'].'" />'."</p>\n</form>";
		$return .= "\n</div>\n";
		return $return;
	}

	function make_the_financial_settings($settings, $labels) {
		if(isset($settings)) {
			$this -> settings = $settings;
		}
		if(isset($labels)) {
			$this -> labels = $labels;
		}
		$return = $this -> make_shipping_input();
		
		$return .= $this -> make_vat_input();
		$return .= $this -> make_currency_input();
		$return .= $this -> make_order_minimum_input();
		return $return;
	}

	function show_netto_switch(){
		$checked = '';
		if($this->settings['show_netto'] == 'true') {$checked = 'checked';}
		$return = "<p><b>Nur zum Test:</b> &nbsp;";
		$return .= "<label><input type=\"checkbox\" name=\"show_netto\" ". $checked ." />Netto-Preise anzeigen</label></p>";
		return $return;
	}
	
	function make_payment_modes_inputs($settings) {
		if(isset($settings)) {
			$this -> settings = $settings;
		}
		$return = "\n<p>";
		$return .= $this -> hints['payment_modes'];
		$return .= "\n<p>\n<form action=\"\" method=\"post\">";
		$modes = array('on_account', 'cash_on_delivery', 'cash_in_advance');
		if($this -> settings['paypal_email']){
			$modes[] = 'pay_pal';
		}
		foreach($modes as $mode) {
			$checked = '';
			if($this -> settings['payment'][$mode]) {
				$checked = 'checked';
			}
			$return .= $this -> make_payment_mode_form($mode, $checked);
		}
		$return .= $this -> make_paypal_account_input();
		$return .= "\n\t</p><p style=\"text-align: right; width: 400px;\"><input type=\"submit\" value=\"".$this -> buttons['save_settings']."\" class=\"shopButton\" /></p>";
		$return .= "\n</form>\n</p>";
		return $return;
	}

	function make_paypal_account_input(){
		if($this->settings['paypal_currency']){
			$my_currency_code = $this->settings['paypal_currency'];
		}
		else{
			$my_currency_code = $this->settings['default_currency'];
			if($my_currency_code == '&euro;') {$my_currency_code = 'EUR';}
			if($my_currency_code == '&pound;') {$my_currency_code = 'GBP';}
			if($my_currency_code == '&yen;') {$my_currency_code = 'JPY';}	
			if($my_currency_code == '$') {$my_currency_code = 'USD';}	
		}
		
		$currency_codes = array(
			'Australian Dollar' => 'AUD',
			'Canadian Dollar' => 'CAD',
			'Euro' => 'EUR',
			'Pounds Sterling' => 'GBP',
			'Yen' => 'JPY',
			'U.S. Dollar' => 'USD',
			'New Zealand Dollar' => 'NZD',
			'Swiss Franc' => 'CHF',
			'Hongkong Dollar' => 'HKD',
			'Singapore Dollar' => 'SGD',
			'Swedish Krona' => 'SEK',
			'Danish Krone' => 'DKK',
			'Polish Zloty' => 'PLN',
			'Norwegian Krone' => 'NOK',
			'Hungarian Forint' => 'HUF',
			'Czech Koruna' => 'CZK',
			'Israeli Shekel' => 'ILS',
			'Mexican Peso' => 'MXN');
		$return ="\n<hr /><b>Paypal</b><br />";
		
		if($this -> settings['paypal_email']) {
			$return .= $this -> hints['paypal_email'] ;
		}else {
			$return .= $this -> hints['no_paypal_email'];
		}
		$return .= "<br />\n";
		$input = new Input();
		$input -> properties = array("type" => "text", "size" => "30", "name" => "paypal_email", "value" => $this -> settings['paypal_email']);
		$return .=  $input -> display_yourself() . "";

			$return .= '<br /><br />'. $this->labels['set_currency'].': ';
			$return .= "\n<select name=\"paypal_currency\">";
			foreach($currency_codes as $key => $val) {
				$checked = '';
				if($val == $my_currency_code) {$checked = 'selected';}
				$return .= "<option  value=\"". $val ."\" ".$checked."/>" .$key ."</option>";
			}
			$return .= "</select>";
		
		return $return;
	}

	function make_payment_mode_form($mode, $checked){

		$return = "<p>\n\t<label><input type=\"checkbox\" $checked id=\"mode_checked\" name=\"".$mode."[enabled]\" /> ". $this -> labels[$mode]." </label><br />";
		$return .= "\n\t&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<label>". $this -> labels['fee'] . '/' . $this -> labels['reduction'] . ': ';
		$return .= "\n\t<input type=\"text\" size=\"4\" style=\"text-align: right;\" id =\"$mode\" name=\"".$mode."[fee]\" value=\"".sprintf("%.2f",$this -> settings['payment_fee'][$mode]). "\" /> ".$this -> settings['default_currency']."\n\t</label>";
		$return .= "\n\t<input type=\"hidden\" name=\"task\" value=\"save_payment_modes\" />";
		$return .= "\n\t<input type=\"hidden\" name=\"settings_task\" value=\"make_payment_modes_inputs\" />";


		return $return;
	}

	function make_shipping_input() {
		$return = '';
		$checked = '';
		$disabled = '';
		$return = "\n<div class = \"settingsForm\">";
	
		$return .= "<form method=\"post\" action=\"\" name=\"financial\">";
		$return .= "<p><fieldset><legend><b>".$this->labels['destination_areas']."/".$this->labels['forwarding_expenses']."</b></legend>";

			$input = new Input();
			
			$return .= "\n<table>\n\t<tr>\n\t\t<th style=\"text-align: left;\">".$this->labels['destination_areas']."</th>"
					."\n\t\t<th style=\"text-align: left;\">".$this->labels['get_vat']."</th>".
					"\n\t\t<th style=\"text-align: left;\">".$this->labels['forwarding_expenses']."</th>\n\t</tr>";
			
			$checked = 'checked=\"checked\"';
			if($this->settings['vat_area']['1'] == 'off') {
				$checked = '';
			}
			$return .= "\n\t<tr>";
			$input->properties = array("type" => "text", "name" => "shipping_1", "value" => $this -> settings[$this -> language]['shipping_1']);
			$return .= "\n\t\t<td>".$input -> display_yourself(). "</td>";
			$return .= "\n\t\t<td><input type=\"checkbox\" name=\"vat_area[1]\"  ". $checked. " /></td>";
			$input->properties = array("type" => "text", "name" => "shipping[1]", "style" => "text-align: right", "size" => 2, "value" => sprintf("%.2f",$this->settings['shipping'][1]));
			$return .= "\n\t\t<td>".$input -> display_yourself() ."&nbsp;".$this -> settings['default_currency']. "</td>";
			$return .= "\n\t</tr>";
			
			$checked = 'checked=\"checked\"';
			if($this->settings['vat_area']['2'] == 'off') {
				$checked = '';
			}
			$return .= "\n\t<tr>";			
			$input->properties = array("type" => "text", "name" => "shipping_2", "value" => $this -> settings[$this -> language]['shipping_2']);
			$return .= "\n\t\t<td>".$input->display_yourself(). "</td>";
			
			$return .= "\n\t\t<td><input type=\"checkbox\" name=\"vat_area[2]\" ".$checked. " /></td>";
			$input->properties = array("type" => "text", "name" => "shipping[2]", "style" => "text-align: right", "size" => 2, "value" => sprintf("%.2f",$this->settings['shipping'][2]));
			$return .= "\n\t\t<td>".$input -> display_yourself() ."&nbsp;".$this -> settings['default_currency']."</td>";
			$return .= "\n\t</tr>";
			
			$checked = 'checked=\"checked\"';
			if($this->settings['vat_area']['3'] == 'off') {
				$checked = '';
			}
			$return .= "\n\t<tr>";			
			$input->properties = array("type" => "text", "name" => "shipping_3", "value" => $this -> settings[$this -> language]['shipping_3']);
			$return .= "\n\t\t<td>".$input -> display_yourself(). "</td>";
			$return .= "\n\t\t<td><input type=\"checkbox\" name=\"vat_area[3]\" ".$checked. " /></td>";
			$input->properties = array("type" => "text", "name" => "shipping[3]", "style" => "text-align: right", "size" => 2, "value" => sprintf("%.2f",$this->settings['shipping'][3]));
			$return .= "\n\t\t<td>".$input -> display_yourself() ."&nbsp;".$this -> settings['default_currency']."</td>";
			$return .= "\n\t</tr>";
			
			$return .= "\n</table>\n";
			
			$js = "for(i=12; i< 14; i++) {window.document.financial.elements[i].disabled=false;}";
			if($this->settings['charge_for_shipping']=='true') {$checked='checked';}
			$return .= "<p>".$this->labels['charge_for_shipping'].'<br />';
			$return .= "\n\t<label><input type=\"radio\" $checked name=\"charge_for_shipping\" value=\"true\" onclick=\"$js\" />".$this->labels['yes']."</label>";
			$checked = '';
		 
			if($this->settings['charge_for_shipping']=='false') {
				$checked='checked';
				$disabled = 'disabled';
			}
			$js = "for(i=12; i < 14; i++) {window.document.financial.elements[i].disabled=true;}";
			$return .= "\n\t<label><input type=\"radio\" $checked name=\"charge_for_shipping\" value=\"false\" onclick=\"$js\" />".$this->labels['no']."</label>";

			$return .= '<p>'.$this->labels['forwarding_expenses_up_to']. '&nbsp;';
			$return .= '<label>'.$this->labels['sum'];
			$return .= '&nbsp;<input '.$disabled.' type="text" size="3" style="text-align:right;" name="no_shipping_sum" value="'.sprintf("%.2f",$this->settings['forwarding_expenses_up_to']['sum']).'" /></label>&nbsp;'.$this -> settings['default_currency'];
			$return .= " <b>". $this->labels['or']. "</b>&nbsp;";
			$return .= '<label>'.$this->labels['items'];
			$return .= '&nbsp;<input '.$disabled.' type="text" size="3" style="text-align:right;" name="no_shipping_items" value="'.$this->settings['forwarding_expenses_up_to']['items'].'" /></label><br />';
			$return .= '</p>';
			$return .= '</fieldset></p></div>';
			return $return;
	}

	function make_vat_input() {
		$return = '<p><fieldset><legend><b>'.$this->labels['vat_settings'].'</b></legend><p>';
		$checked = '';
		if($this->settings['dont_deal_with_taxes']=='true') {
			$checked='checked';
		}
		$return .= '<label><input type="checkbox" name="dont_deal_with_taxes" value="true" '.$checked.' /> '.$this->labels['dont_deal_with_taxes']. '</label>';
		$return .= "\n<p>". $this->labels['vat_rates']."<br />";
		$return .= '<label>'.$this->labels['full_vat'].': ';
		$return .= '<input type="text" size="3" name="vat_full" style="text-align: right;" value ="'.$this->settings['vat_full'].'" /></label> &nbsp;%&nbsp;&nbsp;';
		$return .= '<label>'.$this->labels['reduced_vat'].': ';
		$return .= '<input type="text" size="3" name="vat_reduced" style="text-align: right;" value ="'.$this->settings['vat_reduced'].'" /></label>&nbsp;%';
		$return .= '</p><p>'.$this->labels['vat_default'];
		$checked = '';
		if($this->settings['vat_default']=='full') {
			$checked='checked';
		}
		$return .= '<label><input type="radio" '.$checked.' name="vat_default" value="full" />'.$this->labels['full_vat'].'</label>  | ';
		$checked = '';
		if($this->settings['vat_default']=='reduced') {
			$checked='checked';
		}
		$return .= '<label><input type="radio"'.$checked.' name="vat_default" value="reduced" />'.$this->labels['reduced_vat'].'</label><br />';
		$return .= '</p></fieldset></p>';
		
		return $return;
	}
	function make_currency_input() {
		$return = '<p><fieldset><legend><b>'.$this->labels['set_currency'].'</b></legend><p>';
		$return .= $this->hints['set_currency'].'<br /> ';
		$currency = $this->settings['default_currency'];	
		$checked = '';
			
		if($currency == '&euro;'){
									$checked = 'checked';
									$currency = '';
								}
		$return .= "\n\t<label><input type=\"radio\" $checked name=\"default_currency\" value=\"&amp;euro;\"  /> &euro;</label>&nbsp;&nbsp;&nbsp;&nbsp;";
		$checked = '';
		if($currency == '$') {
									$checked = 'checked';
									$currency = '';	
		}
		$return .= "\n\t<label><input type=\"radio\" $checked name=\"default_currency\" value=\"$\"  /> $</label>&nbsp;&nbsp;&nbsp;&nbsp;";
		$checked = '';
		if($currency == '&pound;') {
									$checked = 'checked';
									$currency = '';
		}
		$return .= "\n\t<label><input type=\"radio\" $checked name=\"default_currency\" value=\"&pound;\"  /> &pound;</label> &nbsp;&nbsp;&nbsp;&nbsp;";
		$checked = '';
		if($currency == '&yen;') {
									$checked = 'checked';
									$currency = '';
		}
		$return .= "\n\t<label><input type=\"radio\" $checked name=\"default_currency\" value=\"&yen;\"  /> &yen;</label><br />";
		$checked = '';
		if($currency !== '') {
									$checked = 'checked';
								
		}
		$return .= "\n\t<label><input type=\"radio\" $checked name=\"default_currency\" value=\"other\"  />".$this->labels['other_currency']. 
		"</label>&nbsp;<input type=\"text\" size=\"5\" name=\"other_currency\" value=\"".$currency."\" />";
		
		$return .= '</p></fieldset></p>';
		return $return;
	}
	function make_order_minimum_input() {
		$return = '<p><fieldset><legend><b>'.$this->labels['minimum_order'].'</b></legend><p>';
		$return .= '<label>'.$this->hints['minimum_order'].':<br />';
		$return .= '<input type="text" size="3" name="minimum_order" style="text-align: right;" value ="'.$this->settings['minimum_order'].'" /></label> &nbsp;'.$this->settings['default_currency'];
		
		$return .= '</p></fieldset></p>';
		$return .= "\n\t<input type=\"hidden\" name=\"task\" value=\"save_financial_settings\" />";
		$return .= "\n\t<input type=\"hidden\" name=\"settings_task\" value=\"make_the_financial_settings\" />";
		$return .= "\n\t".'<p style="text-align: right;"><input type="submit" value="'. $this->buttons['save_settings'].'" />'."</p>\n</form>";
		return $return;
	}

	/**
	 * die Produkte als html-table ausgeben
	 * @param array $products
	 * @return html-String
	 */
	function list_products($products){
		global $buttons, $labels, $sl;
		foreach ($products as $product) {
			if(!is_a($product, 'Product')) {
				unset($this->catalogue->products[$product->counter]);
			}
		}
		$amount = count($products);
		if ($amount > 0) {
			$return = "<p>$amount ".$this -> labels['products_found']."</p>";
			$return .= "\n<table id='productsList'>";
			$i = 1;
			foreach ($products as $product) {
				if(is_a($product, 'Product')) {
					$return .= "\n<tr>";
					
					$return .= $product -> present_yourself_for_admins_table($sl, $this -> button_image_folder, $amount, $this -> labels, $i,$this -> settings['default_currency'],$this->writer);
					$i++;
				}
				else {unset($this->catalogue->products[$product->counter]);}
				$return	.= "\n</tr>";
			}
			$return .= "\n</table>";
		}
		else {
			$return .= "\n<p>".$this -> labels['no_products_found']."</p>";
		}
		return $return;
	}
	function create_category_selector_form($categories, $standard_category) {
		$return = "\n<p>\n<form method = \"post\" action=\"\" class=\"inline\">";
		$return .= "\n\t".$this -> labels['product_categories']."\n\t<input type =\"hidden\" name=\"product_admnistration_task\" value=\"list_products\" />";
		$return .= "\n\t<input type =\"hidden\" name=\"task\" value=\"administrate_products\" />";
		$return .= "\n\t<select  name=\"chosen_category\" ";
		$return .= "onchange=\"this.parentNode.submit(); \"";
		$return .= ">";
		$return .= "\n\t<option value =\"all_categories\">".$this->labels['all_categories']."</option>";
		foreach($categories as $category) {
			$selected = '';
			if($_POST['chosen_category'] == $category) {
				$selected = 'selected';
			}
			$return .= "\n\t<option value=\"$category\" $selected>$category</option>";
		}
		$selected = '';
		if($_POST['chosen_category'] == 'left_overs') {
			$selected = 'selected';
		}
		$return .= "\n\t<option value =\"left_overs\" $selected >".$standard_category."</option>";
		$return .= "\n\t</select>&nbsp;\n<noscript><input type=\"submit\" class=\"shopButton\" value=\"[anzeigen]\">\n</noscript>\n</form>\n";
		return $return;

	}
	function make_product_form($product, $categories, $product_count) {
		if(isset($product)) {
			$lang = $this -> language;
			$name = $product -> get_the_name($lang);
			$description = $product -> get_the_description($lang);
			$image = $product -> previewPicture;
			$linked_pages = $product -> productPages[$lang];
			$counter = "#".$product -> counter;
		} else {$counter = "#". $product_count;}

		$return = "\n<form action=\"$counter\" method = \"post\" />";
		$return .= $this -> make_product_name_input($name);
		$return .= $this -> make_product_image_input($image);
		$return .= $this -> make_product_description_input($description);
		$return .= $this -> make_product_price_input($product -> price);
		$return .= $this -> make_product_vat_input($product);
		$return .= $this -> make_product_categories_input($product, $categories);
		$return .= $this -> make_linked_pages_input($product);
		$input = new Input();
		$return .= "\n<p style=\"text-align: right;\">";
		$input -> properties = array('type' => 'submit',
								'value' => $this -> buttons['save_settings']);
		$return .= $input -> display_yourself();
		$input -> properties = array('type' => 'hidden',
								 'name' => 'task',
								'value' => 'save_product');
		$return .= $input -> display_yourself();
		$return .= $input -> display_yourself();
		$input -> properties = array('type' => 'hidden',
								 'name' => 'product_index',
								'value' => $product -> counter);
		$return .= $input -> display_yourself();

		$return .= "\n</p>\n</form>";
		return $return;
	}

	function make_product_name_input($name) {
		$return = "\n\t<p><label><b>".$this -> labels['product_name'] ."</b><br />";
		$properties = array('type' => 'text',
						'name' => 'name',
						'value' => $name,
						'size' => 60);
		$input = new Input();
		$input -> properties = $properties;
		$return .= $input -> display_yourself();
		$return .= "\n\t</label></p>";
		return $return;
	}

	function make_product_description_input($description) {

		if($this -> description_editor){
		 $this -> init_tinymce();
		}
		$description = stripslashes(str_replace("<br />","\n",$description));
		$return .= "\n<p><label><b>". $this -> labels['product_description']."</b><br />" .
				"<textarea name=\"description\" id=\"description\" cols=\"70\" rows=\"10\">"
				.$description."</textarea></label></p>";
				return $return;

	}

	function init_tinymce(){
		global $hjs, $pth, $cf,$sn,$sl;
		
		$hjs .= '<script language="javascript" type="text/javascript" src="'.$pth['folder']['base'].$cf['tinymce']['folder'].'/tiny_mce.js"></script>
				<script language="javascript" type="text/javascript">
					
				tinyMCE.init({
					plugins : "table,advimage,advlink,media,contextmenu,",
					mode: "textareas",
					theme: "advanced",
					language: "'.$sl.'",
					content_css: "'.$sn.'?&stylesheet",
					theme_advanced_toolbar_location : "top",
				  	theme_advanced_toolbar_align : "left",
				    theme_advanced_buttons1 : "bold,italic,|,bullist,numlist,|,charmap,|,indent,outdent,|,link,unlink,|,undo,redo,|,help,code,",
					theme_advanced_buttons2 : "",
					theme_advanced_buttons3 : ""});
				</script>';
						
	}
	function make_product_price_input($price) {
		$return = "\n\t<p><label><b>".$this -> labels['price'] ."</b>: ";
		$properties = array('type' => 'text',
						'name' => 'price',
						'value' => $price,
						'size' => 5);
		$input = new Input();
		$input -> properties = $properties;
		$return .= $input -> display_yourself();
		$return .= "\n\t</label>&nbsp;".$this -> settings['default_currency']."</p>";
		return $return;
	}

	function make_product_image_input($picture) {
		global $pth;
		$return = "\n\t<p><b>".$this -> labels['preview_picture'].":</b>";
		if ($handle = opendir($pth['folder']['images'])) {
			$selected = '';
			if($picture <> '') {$selected = 'selected';}
			$return .= "\n<select name =\"preview_pic\" />";
			$return .= "\n\t<option value=\"\" style=\"min-width: 250px\" >kein Vorschaubild</option>";
			while (false !== ($file = readdir($handle))) {
				if(preg_match('/[^\.]*\.(gif|jpeg|jpg|png)/i',$file)) {
					$selected = '';
					$options[] = $file;
					if($picture == $file) {$selected = 'selected';}
					$return .= "\n\t<option value=\"$file\" $selected>$file</option>";
				}
			}
			closedir($handle);
			$return .= "</select><br />";
		}
		return $return;
	}

	function make_product_vat_input($product) {
		$checked = '';
		$vat = $this -> settings['vat_default'];
		if($product) {$vat = $product -> vat;}
		if($vat =='full') {
			$checked='checked';
		}
		$return .= "\n\t<p><b>". $this -> labels['vat_rate']. ":</b>&nbsp;&nbsp;\n\t";
		$return .= '<label><input type="radio" '.$checked.' name="vat" value="full" />'.$this->labels['full_vat'].'</label>  | ';
		$checked = '';
		if($vat == 'reduced') {
			$checked='checked';
		}
		$return .= '<label><input type="radio"'.$checked.' name="vat" value="reduced" />'.$this->labels['reduced_vat'].'</label></p>';
		return $return;
	}

	function make_linked_pages_input($product) {
		global $u, $h, $l, $sl;   //url, heading, level
		$pages = '';
		for($i = 0;$i < (count($u)); $i++) {
			$spacer = '';
			if($l[$i] > 1){
				$spacer = str_repeat('&nbsp;&nbsp;&nbsp;', $l[$i]);
			}
			if($u[$i] !== $this -> zUrl){
				$links[$i]['link'] = "?".$u[$i];
				$links[$i]['page'] = $spacer.$h[$i];
			}
	 }
	 $return = "\n\t<p><label><b>".$this -> labels['internal_link']."</b><br /> ";
	 $return .= "\n<select name=\"productPages[]\" multiple size=\"10\" style=\"min-width: 250px\">";
	 foreach ($links as $link) {
	 	$selected = '';
	 	if(in_array($link['link'],$product -> productPages[$sl])) {
	 		$selected = 'selected';
	 	}
	 	$return .= "\n\t<option $selected style=\"min-width: 250px\" value =\"".$link['link']."\">".$link['page']."</option>";
	 }
	 $return .= "\n</select></label></p>";
	 return $return;
	}

	function make_product_categories_input($product, $categories) {
		$language = $this -> language;
		$return = "\n\t<p><label><b>".$this -> labels['product_categories']."</b><br /> ";
		if($categories == null){
			$return .= $this -> hints['no_categories'];
			return $return;
		}
		$return .= "\n<select name=\"product_categories[]\" multiple size=\"10\" style=\"min-width: 250px\">";
		foreach ($categories as $category) {
			$selected = '';
			if(in_array($category, $product -> categories[$language])) {
				$selected = 'selected';
			}

			$return .= "\n\t<option $selected style=\"min-width: 250px\" value =\"".$category."\">".$category."</option>";
		}
		$return .= "\n</select></label></p>";
		return $return;
	}

	function make_categories_edit_form($categories, $standard_category, $default_category) {
		$return = '';
		$i = 0;
		if(!isset($standard_category)) {
			$standard_category = $this -> settings[$this -> language]['category_for_left_over_products'];
		}
		$return .= "\n<label ><p>".$this -> hints['new_category']."<form action = \"\" method = \"post\"  />";
		$return .= "\n\t<input type=\"text\" name=\"new_category\" value=\"\" size =\"40\"/>";
		$return .= "\n\t<input type=\"hidden\" name=\"task\" value=\"administrate_products\" />";
		$return .= "\n\t<input type=\"hidden\" name=\"product_administration_task\" value=\"edit_categories\" />";
		$return .= "\n\t<input type=\"submit\"  class=\"shopButton\" value=\"o.k.\" /></p>";
		$return .= "\n</form><br />\n</p>";

		$return .= "\n<p>". $this -> hints['left_over_category'];
		$return .= "\n<form action = \"\" method = \"post\">";
		$return .= "\n\t<input type=\"text\" name=\"left_over_category\" value=\"".$standard_category."\" size =\"40\"/>";
		$return .= "\n\t<input type=\"hidden\" name=\"task\" value=\"administrate_products\" />";
		$return .= "\n\t<input type=\"hidden\" name=\"product_administration_task\" value=\"edit_categories\" />";
		$return .= "\n\t<input type=\"submit\"  class=\"shopButton\" value=\"o.k.\" /></p>";
		$return .= "\n</form></label><br /></p>\n";

		if(count($categories) > 0) {
			$return .= "\n<p>".$this -> hints['current_categories'] ."\n</p>";
		}
		$return .= "\n<table style=\"\">";
		$i = 0;
		foreach($categories as $category) {
			$return .= "\n<tr>\n\t<td>";
			$return .= $this -> create_the_move_categories_forms($i, count($categories)). "\n\t</td>\n\t<td>";
			$return .= "\n\t<form action = \"\" method = \"post\" style=\"display: inline\">";
			$return .= "\n\t\t<input type=\"text\" name=\"old_category\" value=\"$category\" size =\"40\"/>";
			$return .= "\n\t\t<input type=\"hidden\" name=\"task\" value=\"administrate_products\" />";
			$return .= "\n\t\t<input type=\"hidden\" name=\"product_administration_task\" value=\"edit_categories\" />";
			$return .= "\n\t\t<input type=\"hidden\" name=\"category_index\" value=\"$i\" />";
			$return .= "\n\t\t<input type=\"submit\"  class=\"shopButton\" value=\"o.k.\" />";
			$return .= "\n\t</form>\n\t</td>\n</tr>";
			$i++;
		}
		$return .= "\n</table>\n<div ><br />" . $this -> hints['default_category'];
		$checked = '';
		if($default_category == $this -> labels['all_categories']) {
			$checked = 'checked';
		}
		$return .= "\n<form action =\"\" method=\"post\">";
		$return .= "\n\t<label><input type=\"radio\" name = \"default_category\" value = \"".$this -> labels['all_categories']."\" $checked /> ".$this -> labels['all_categories'] ."</label><br />";

		foreach($categories as $category) {
			$checked = '';
			if($default_category == $category) {
				$checked = 'checked';
			}
			$return .= "\n\t<label><input type=\"radio\" name=\"default_category\" value=\"$category\" $checked /> $category</label><br />";
		}
		$return .= "\n\t<input type=\"hidden\" name=\"task\" value=\"administrate_products\" />";
		$return .= "\n\t<input type=\"hidden\" name=\"product_administration_task\" value=\"edit_categories\" />";
		$return .= "\n\t<input type=\"hidden\" name=\"category_index\" value=\"$i\" />";
		$return .= "\n\t<p style=\"text-align: right;\"><input type=\"submit\"  class=\"shopButton\" value=\"".$this -> buttons['save_settings']."\" /></p>";

		$return .= "\n</form>\n</div>";

		return $return;
	}

	function create_the_move_categories_forms($i, $categories_size) {
		if($i == 0) {
			$return = "<image src=\"". $this -> button_image_folder."arrowspacer.gif\" />";
			$return .= $this -> create_move_category_down_form($i);
			return $return;

		}
		if($i == ($categories_size-1)) {
			$return = $this -> create_move_category_up_form($i);
			$return .= "<image src=\"". $this -> button_image_folder."arrowspacer.gif\" />";
			return $return;
		}
		else {
			$return = $this -> create_move_category_up_form($i);
			$return .=  $this -> create_move_category_down_form($i);
			return $return;

		}
	}

	function create_move_category_up_form($index) {
		$return = "\n\t<form style=\"display: inline;\" action=\"\" method=\"post\" />";
		$return .= "\n\t\t<input type=\"hidden\" name = \"move_this_up\" value = \"$index\">";
		$return .= "\n\t\t<input type=\"hidden\" name = \"task\" value = \"administrate_products\">";
		$return .= "\n\t\t<input type=\"hidden\" name = \"product_administration_task\" value = \"edit_categories\">";
		$return .= "\n\t\t<input style=\"padding: 0px; spacing: 0px;\" type=\"image\"  alt=\"move up button\"  title=\"move category up\" src=\"".$this -> button_image_folder."uparrow.gif\" />";
		$return .= "\n\t</form>";
		return $return;
	}
	function create_move_category_down_form($index) {
		$return = "\n\t<form style=\"display: inline;\" action=\"\" method=\"post\" />";
		$return .= "\n\t\t<input type=\"hidden\" name = \"move_this_down\" value = \"$index\">";
		$return .= "\n\t\t<input type=\"hidden\" name = \"task\" value = \"administrate_products\">";
		$return .= "\n\t\t<input type=\"hidden\" name = \"product_administration_task\" value = \"edit_categories\">";
		$return .= "\n\t\t<input type=\"image\" style=\"padding: 0px; spacing: 0px;\" alt=\"move down button\"  title=\"move category down\" src=\"".$this -> button_image_folder."downarrow.gif\" />";
		$return .= "\n\t</form>";
		return $return;
	}
}
?>
